HS_restartWarningFlag = false
HS_restartFlag = false
HS_timeCounter = 0
HS_convoyCounter = {blue = 0,red = 0}
HS_menuItems = {blue = {}, red = {}}
HS_groupsInNeed = {blue = {}, red = {}}
HS_humanCargo = {["UH-1H"] = 8, ["Mi-8MT"] = 16}
HS_checkForSmokeList = {blue = {}, red = {}}
HS_checkForFlareList = {blue = {}, red = {}}
HS_checkForIncomingList = {blue = {}, red = {}}
HS_numberOfTroopsInCabin = {blue = {}, red = {}}
HS_rescuedPilotsInCabin = {blue = {}, red = {}}
HS_slingLoad = {blue = {}, red = {}}
HS_opponent = {blue = 'red',red = 'blue'}
HS_wingmen = {blue = {},red ={}}
HS_pilotCounter = {blue = 0,red = 0}
HS_pilotDownCounter = {blue = 0,red = 0}
HS_temporaryGroupCounter = 0
HS_casualtyReport = false
HS_incomingAudio = 'incoming.wav' -- name of audio file that is played when copilot reports incoming missile (must be included in the .miz file)
HS_detectionRange = 10000 -- distance in meters, only helicopters within that distance from the missile launch site will detect the missile
HS_reactionTime = 0.5 -- time in seconds between launch of the missile and detection by the copilot
HS_radioStatic = 'RadioClickAfter.wav'
HS_upSound = 'up.wav'
HS_downSound = 'down.wav'
HS_leftSound = 'left.wav'
HS_rightSound = 'right.wav'
HS_forwardSound = 'forward.wav'
HS_backSound = 'back.wav'
HS_beaconSound = 'VHF_WarningTone.wav'

HS_ADFlist = {
	blue = {},
	red = {
		{name = 'ARK-UD channel 1', frequency = 114166000, modulation = 0, group = nil},
		{name = 'ARK-UD channel 2', frequency = 114333000, modulation = 0, group = nil},
		{name = 'ARK-UD channel 3', frequency = 114583000, modulation = 0, group = nil},
		{name = 'ARK-UD channel 4', frequency = 121500000, modulation = 0, group = nil},
		{name = 'ARK-UD channel 5', frequency = 123100000, modulation = 0, group = nil},
		{name = 'ARK-UD channel 6', frequency = 124100000, modulation = 0, group = nil},
		{name = 'R-828 channel 1', frequency = 35654000, modulation = 0, group = nil},
		{name = 'R-828 channel 2', frequency = 25675000, modulation = 0, group = nil},
		{name = 'R-828 channel 3', frequency = 48543500, modulation = 0, group = nil},
		{name = 'R-828 channel 4', frequency = 35657500, modulation = 0, group = nil},
	}
}

HS_airfields = {
[1] = {name = 'Khersones', id = 1},
[2] = {name = 'Saki', id = 2},
[3] = {name = 'Simpheropol', id = 3},
[4] = {name = 'Razdolnoe', id = 4}, 
[5] = {name = 'Dzhankoy', id = 5},
[6] = {name = 'Kirovskoe', id = 6},
[7] = {name = 'Kerch', id = 7},
[8] = {name = 'Belbek', id = 8},
[9] = {name = 'Krasnogvardeyskoye', id = 9},
[10] = {name = 'Octyabrskoe', id = 10},
[11] = {name = 'Gvardeyskoe', id = 11},
[12] = {name = 'Anapa-Vityazevo', id = 12},
[13] = {name = 'Krasnodar', id = 13},
[14] = {name = 'Novorossiysk', id = 14},
[15] = {name = 'Krymsk', id = 15},
[16] = {name = 'Maykop-Khanskaya', id = 16},
[17] = {name = 'Gelendzhik', id = 17},
[18] = {name = 'Sochi-Adler', id = 18},
[19] = {name = 'Krasnodar-Pashkovsky', id = 19}, 
[20] = {name = 'Sukhumi-Babushara', id = 20},
[21] = {name = 'Gudauta', id = 21},
[22] = {name = 'Batumi', id = 22},
[23] = {name = 'Senaki-Kolkhi', id = 23},
[24] = {name = 'Kobuleti', id = 24},
[25] = {name = 'Kutaisi', id = 25},
[26] = {name = 'Mineralnye Vody', id = 26},
[27] = {name = 'Nalchik', id = 27},
[28] = {name = 'Mozdok', id = 28},
[29] = {name = 'Tbilisi-Lochini', id = 29},
[30] = {name = 'Soganlug', id = 30},
[31] = {name = 'Vaziani', id = 31},
[32] = {name = 'Beslan', id = 32}
}

HS_INCOM_outUnit = function(forUnit,outText,outTime) -- function outputs text to a specific unit using the mist message system

	if outText and outTime then
		local msg = {}
		msg.text = outText
		msg.displayTime = outTime
		msg.msgFor = {units = {forUnit}}
		msg.sound = HS_incomingAudio
		mist.message.add(msg)
	end
end

HS_outUnit = function(forUnit,outText,outTime) -- function outputs text to a specific unit using the mist message system

	if outText and outTime then
		local msg = {}
		msg.text = outText
		msg.displayTime = outTime
		msg.msgFor = {units = {forUnit}}
		msg.sound = HS_radioStatic
		mist.message.add(msg)
	end
end

HS_out = function(coa,outText,outTime) -- function outputs text using the mist message system

	if outText and outTime then
		local msg = {}
		msg.text = outText
		msg.displayTime = outTime
		msg.msgFor = {coa = {coa}}
		msg.sound = HS_radioStatic
		mist.message.add(msg)
	end
end

HS_airfieldList = {blue = {}, red = {}}
local count

for count = 1,#HS_airfields do
	local airbase = Airbase.getByName(HS_airfields[count].name)
	if airbase then
		local coa = Airbase.getCoalition(airbase)
		local position = Airbase.getPosition(airbase).p
		if  mist.utils.get2DDist(position,mist.utils.zoneToVec3 ('Airfield Zone')) < mist.DBs.zonesByName['Airfield Zone'].radius then
			if coa == coalition.side.RED then
				coa = 'red'
				table.insert(HS_airfieldList[coa],HS_airfields[count].name)
			elseif coa == coalition.side.BLUE then
				coa = 'blue'
				table.insert(HS_airfieldList[coa],HS_airfields[count].name)
			end
		end
	end
end

HS_getUnit = function(unitName)
local unit

	if type(unitName) == 'string' then
		unit = Unit.getByName(unitName)
	else
		unit = unitName
	end
	return unit
end

HS_getGroup = function(groupName)
local group

	if type(groupName) == 'string' then
		group = Group.getByName(groupName)
	else
		group = groupName
	end
	return group
end

HS_isGroupDead = function(coa,groupName)

	local group = HS_getGroup(groupName)
	if group then
		mist.scheduleFunction(HS_isGroupDead,{coa,groupName},timer.getTime()+10)
	else
		HS_out(coa,'This is ' .. groupName .. '. I am the last man stand...',10)
		HS_groupsInNeed[coa][groupName] = nil
	end
end

HS_isInfantryGroupInNeed = function(coa,groupName)

	local group = HS_getGroup(groupName)
	if group then
		if Group.getSize(group) < 15 and not HS_groupsInNeed[coa][groupName] then
			HS_out(coa,'This is ' .. groupName .. '. We are taking heavy losses and need immediate reinforcements.',10)
			HS_groupsInNeed[coa][groupName] = true
		end
		if Group.getSize(group) > 20 and HS_groupsInNeed[coa][groupName] then
			HS_out(coa,'This is ' .. groupName .. '. Thanks for the reinforcement troops. Knew we can count on you. Out.',10)
			HS_removeADF(coa,groupName)
			HS_groupsInNeed[coa][groupName] = nil
		end
		mist.scheduleFunction(HS_isInfantryGroupInNeed,{coa,groupName},timer.getTime()+10)
	end
end

HS_getAvgPos = function(groupName)
local count

	local totalPosition = {x = 0,y = 0,z = 0}
	local group = HS_getGroup(groupName)
	if group then
		local units = Group.getUnits(group)
		for count = 1,#units do
			if units[count] then 
				totalPosition = mist.vec.add(totalPosition,Unit.getPosition(units[count]).p)
			end
		end
		if #units > 0 then
			return mist.vec.scalar_mult(totalPosition,1/#units)
		else
			return nil
		end
	else
		return nil
	end
end

HS_getHeading = function (position1,position2) -- determine heading from point 1 to point 2
local heading

	if position1 and position2 then
		local heading = math.floor(math.atan2(position1.z-position2.z,position1.x-position2.x)*57.3)
		if heading<0 then
			heading=heading+360
		end
		return heading
	else
		return 0
	end
end

HS_getUnitCoalition = function(playerName)
local unit

	if type(playerName) == 'string' then
		unit = Unit.getByName(playerName)
	else
		unit = playerName
	end
	if Unit.getCoalition(unit) == coalition.side.BLUE then
		return 'blue'
	else
		return 'red'
	end
end

HS_getGroupCoalition = function(playerGroupName)
local group

	if type(playerGroupName) == 'string' then
		group = Group.getByName(playerGroupName)
	else
		group = playerGroupName
	end
	if Group.getCoalition(group) == coalition.side.BLUE then
		return 'blue'
	else
		return 'red'
	end
end

HS_groupSetCommand = function(groupName,action)
local group
local groupController

	if groupName then
		group = HS_getGroup(groupName)
		if group then
			groupController = Group.getController(group)
			Controller.setCommand(groupController,action)
		end
	end
end

HS_groupDoNotDisperse = function(groupName)
local action = 	{
					["id"] = "Option",
					["params"] = 
					{
						["name"] = 8,
					}, -- end of ["params"]
				} -- end of ["action"]
	HS_groupSetCommand(groupName,action)
end

HS_stopTransmission = function(groupName)
local action = 	{
					["id"] = "StopTransmission",
					["params"] = 
					{
					}, -- end of ["params"]
				} -- end of ["action"]
	HS_groupSetCommand(groupName,action)
end

HS_startTransmission = function(groupName)
local action =	{
				["id"] = "TransmitMessage",
				["params"] = 
				{
					["file"] = HS_beaconSound,
					["subtitle"] = "",
					["loop"] = true,
					["duration"] = 5,
				}, -- end of ["params"]
			} -- end of ["action"]
	HS_groupSetCommand(groupName,action)
end

HS_groupSetADF = function(groupName,ADF,modulation)
local action =	{
				["id"] = "SetFrequency",
				["params"] = 
				{
					["modulation"] = modulation,
					["frequency"] = ADF,
				}, -- end of ["params"]
			} -- end of ["action"]
	HS_groupSetCommand(groupName,action)
end

HS_groupStart = function(groupName)
local action = 	{
					["id"] = "Start",
					["params"] =
					{
					}, -- end of ["params"]
				} -- end of ["action"]
	HS_groupSetCommand(groupName,action)
end

HS_onTouchDownDo_sub1 = function(unitInAir,unitName,code,arguments)
	local unit = HS_getUnit(unitName)
	if unit and Unit.isActive(unit) then
		if unitInAir and not Unit.inAir(unit) then
			mist.scheduleFunction(code,arguments,timer.getTime()+0.1)
		end
		mist.scheduleFunction(HS_onTouchDownDo_sub1,{Unit.inAir(unit),unitName,code,arguments},timer.getTime()+1)
	end
end

HS_onTouchDownDo = function(unitName,code,arguments)
	local unit = HS_getUnit(unitName)
	if unit and Unit.isActive(unit) then
		mist.scheduleFunction(HS_onTouchDownDo_sub1,{Unit.inAir(unit),unitName,code,arguments},timer.getTime()+1)
	end
end

HS_onTakeOffDo_sub1 = function(unitInAir,unitName,code,arguments)
	local unit = HS_getUnit(unitName)
	if unit and Unit.isActive(unit) then
		if not unitInAir and Unit.inAir(unit) then
			mist.scheduleFunction(code,arguments,timer.getTime()+0.1)
		end
		mist.scheduleFunction(HS_onTakeOffDo_sub1,{Unit.inAir(unit),unitName,code,arguments},timer.getTime()+1)
	end
end

HS_onTakeOffDo = function(unitName,code,arguments)
	local unit = HS_getUnit(unitName)
	if unit and Unit.isActive(unit) then
		mist.scheduleFunction(HS_onTakeOffDo_sub1,{Unit.inAir(unit),unitName,code,arguments},timer.getTime()+1)
	end
end

HS_onBecomesActiveDo_sub1 = function(unitIsActive,unitName,code,arguments)
	local unit = Unit.getByName(unitName)
	if unit then
		if Unit.isActive(unit) and not unitIsActive then
			mist.scheduleFunction(code,arguments,timer.getTime()+0.1)
		end
		mist.scheduleFunction(HS_onBecomesActiveDo_sub1,{Unit.isActive(unit),unitName,code,arguments},timer.getTime()+1)
	else
		mist.scheduleFunction(HS_onBecomesActiveDo_sub1,{false,unitName,code,arguments},timer.getTime()+1)
	end
end

HS_onBecomesActiveDo = function(unitName,code,arguments)
	mist.scheduleFunction(HS_onBecomesActiveDo_sub1,{false,unitName,code,arguments},timer.getTime()+1)
end

HS_onBecomesInactiveDo_sub1 = function(unitIsActive,unitName,code,arguments)
	local unit = Unit.getByName(unitName)
	if unit then 
		mist.scheduleFunction(HS_onBecomesInactiveDo_sub1,{Unit.isActive(unit),unitName,code,arguments},timer.getTime()+1)
	else
		if unitIsActive then
			mist.scheduleFunction(code,arguments,timer.getTime()+0.1)
		end
		mist.scheduleFunction(HS_onBecomesInactiveDo_sub1,{false,unitName,code,arguments},timer.getTime()+1)
	end
end

HS_onBecomesInactiveDo = function(unitName,code,arguments)
	mist.scheduleFunction(HS_onBecomesInactiveDo_sub1,{false,unitName,code,arguments},timer.getTime()+1)
end

HS_addGroundGroup = function(country,groupName,unitType,numberOfTroops,position)
local i
local units = {}
local unitPosition
local country2

	if country == 'blue' then
		country2 = 'USA'
	elseif country == 'red' then
		country2 = 'RUSSIA'
	else
		country2 = country
	end

	for i =1,numberOfTroops do
		unitPosition = mist.getRandPointInCircle(mist.utils.makeVec3(position), 4*math.sqrt(numberOfTroops)) -- get random position for individual unit
		table.insert(units,
		{
			["x"] = unitPosition.x,
			["y"] = unitPosition.y,
			["type"] = unitType,
			["name"] = groupName .. ' Unit #' .. i,
			["heading"] = 0,
			["skill"] = "Random"
		})
	end
	if #units > 0 then
		mist.dynAdd({country = country2, category = 'GROUND_UNIT', name = groupName, hidden = false, units = units })
		return groupName
	else
		return nil
	end
end

HS_addInfantryGroup = function(country,groupName,numberOfTroops,position)
local unitType

	if country == 'blue' or country == 'USA' or country == 'usa' then
		unitType = 'Soldier M4'
	else
		unitType = 'Infantry AK'
	end
	local groupName = HS_addGroundGroup(country,groupName,unitType,numberOfTroops,position)
	if string.sub(groupName,1,string.len('Airfield')) == 'Airfield' then
		local group = HS_getGroup(groupName)
		mist.scheduleFunction(trigger.action.setGroupAIOff,{group},timer.getTime()+1)
	end
	return groupName
end

HS_isGroupInfantry = function(groupName)
local count

	local group = HS_getGroup(groupName)
	if group then
		local units = Group.getUnits(group)
		for count =1,#units do
			if units[count] then
				local unitName = Unit.getName(units[count])
				local unitType = Unit.getByName(unitName):getTypeName()
				if unitType == 'Soldier M4' or unitType == 'Infantry AK' then
					return unitName
				end
			end
		end
	end
	return nil
end

HS_moveGroup = function(groupName,B,pathType,speed)

	local group = HS_getGroup(groupName)
	if group then
		local endPoint = mist.utils.makeVec2(B)
		path = {}
		path[#path + 1] = mist.ground.buildWP(HS_getAvgPos(groupName),pathType,speed) -- first point on path is present position
		path[#path + 1] = mist.ground.buildWP(endPoint,pathType,speed) -- second point on path is target position
		mist.goRoute(groupName, path) -- schedule ground unit move
	end
end

HS_moveGroupToGroup = function(groupName,targetGroupName,pathType,speed)

	local startPoint = HS_getAvgPos(groupName)
	local endPoint = HS_getAvgPos(targetGroupName)
	local relativeVector = mist.vec.sub(startPoint,endPoint)
	relativeVector = mist.vec.scalar_mult(relativeVector,20/(mist.vec.mag(relativeVector)+1))
	endPoint = mist.vec.add(endPoint,relativeVector)
	HS_moveGroup(groupName,endPoint,pathType,speed)
	mist.scheduleFunction(HS_moveGroupToGroup,{groupName,targetGroupName,pathType,speed},timer.getTime()+20)
end

HS_moveGroupToUnit = function(groupName,targetUnitName,pathType,speed)

	local startPoint = HS_getAvgPos(groupName)
	local endPoint = Unit.getPosition(HS_getUnit(targetUnitName)).p
	local relativeVector = mist.vec.sub(startPoint,endPoint)
	relativeVector = mist.vec.scalar_mult(relativeVector,20/(mist.vec.mag(relativeVector)+1))
	endPoint = mist.vec.add(endPoint,relativeVector)
	HS_moveGroup(groupName,endPoint,pathType,speed)
	mist.scheduleFunction(HS_moveGroupToUnit,{groupName,targetUnitName,pathType,speed},timer.getTime()+20)
end

HS_closestInfantryGroup = function (coa,playerName,excludeList)
local groupName,value,count

	local closestOne = nil
	local distance = 1E6
	local playerUnit = HS_getUnit(playerName)
	if playerUnit then
		local playerPosition = Unit.getPosition(playerUnit).p
		for groupName,value in pairs(mist.DBs.groupsByName) do
			if HS_isGroupInfantry(groupName) then
				local exclude = false
				if excludeList then
					for count = 1,#excludeList do
						if string.sub(groupName,1,string.len(excludeList[count])) == excludeList[count] then
							exclude = true
						end
					end
				end
				if HS_getGroupCoalition(groupName) == coa and not exclude then
					local infantryPosition = HS_getAvgPos(groupName) 
					if mist.utils.get2DDist(playerPosition,infantryPosition) < distance then
						distance = mist.utils.get2DDist(playerPosition,infantryPosition)
						closestOne = groupName
					end
				end
			end
		end
	end
	return closestOne,distance
end

HS_closestInfantryGroupWithPrefix = function(coa,playerPosition,prefix)
local groupName,value,count

	local closestOne = nil
	local distance = 1E6
	for groupName,value in pairs(mist.DBs.groupsByName) do
		if HS_isGroupInfantry(groupName) then
			if HS_getGroupCoalition(groupName) == coa and string.sub(groupName,1,string.len(prefix)) == prefix then
				local infantryPosition = HS_getAvgPos(groupName) 
				if mist.utils.get2DDist(playerPosition,infantryPosition) < distance then
					distance = mist.utils.get2DDist(playerPosition,infantryPosition)
					closestOne = groupName
				end
			end
		end
	end
	return closestOne,distance
end

HS_totalInfantrySize = function (coa,excludeList)
local groupName,value,count

	local totalSize = 0
	for groupName,value in pairs(mist.DBs.groupsByName) do
		if HS_isGroupInfantry(groupName) then
			local exclude = false
			if excludeList then
				for count = 1,#excludeList do
					if string.sub(groupName,1,string.len(excludeList[count])) == excludeList[count] then
						exclude = true
					end
				end
			end
			if HS_getGroupCoalition(groupName) == coa and not exclude then
				local group = Group.getByName(groupName)
				if group then
					totalSize = totalSize + Group.getSize(group)
				end
			end
		end
	end
	return totalSize
end

HS_makeInfantryMove = function()
local distance
local closestOne
local groupName,value

	for groupName,value in pairs(mist.DBs.groupsByName) do
		local unitName = HS_isGroupInfantry(groupName)
		if unitName and string.sub(groupName,1,string.len('Airfield')) ~= 'Airfield' and string.sub(groupName,1,string.len('Pilot Down')) ~= 'Pilot Down' and string.sub(groupName,1,string.len('Temporary')) ~= 'Temporary' then
			local coa = HS_getGroupCoalition(groupName)
			closestOne,distance = HS_closestInfantryGroup(HS_opponent[coa],unitName,{'Temporary','Airfield','Pilot Down'})
			if closestOne then
				mist.scheduleFunction(HS_moveGroup,{groupName,HS_getAvgPos(closestOne),'Off Road',10},timer.getTime()+1)
			end
		end
	end
end

HS_groundBattle = function(numberOfInfantryGroups,groupSize,battleZoneName,coalitionZones)
local count,position

	for count = 1,numberOfInfantryGroups do
		repeat
			position = mist.getRandPointInCircle(mist.utils.zoneToVec3(battleZoneName),mist.DBs.zonesByName[battleZoneName].radius)
		until mist.utils.get2DDist(position, mist.utils.zoneToVec3(coalitionZones.blue)) < mist.DBs.zonesByName[coalitionZones.blue].radius
		HS_addInfantryGroup('USA','US Infantry Group #' .. count,mist.random(math.floor(groupSize/2),math.floor(groupSize*1.5)),position)
		repeat
			position = mist.getRandPointInCircle(mist.utils.zoneToVec3(battleZoneName),mist.DBs.zonesByName[battleZoneName].radius)
		until mist.utils.get2DDist(position, mist.utils.zoneToVec3(coalitionZones.red)) < mist.DBs.zonesByName[coalitionZones.red].radius
		HS_addInfantryGroup('RUSSIA','Russian Infantry Group #' .. count,mist.random(math.floor(groupSize/2),math.floor(groupSize*1.5)),position)
		mist.scheduleFunction(HS_isGroupDead,{'blue','US Infantry Group #' .. count},timer.getTime()+1)
		mist.scheduleFunction(HS_isInfantryGroupInNeed,{'blue','US Infantry Group #' .. count},timer.getTime()+2)
		mist.scheduleFunction(HS_isGroupDead,{'red','Russian Infantry Group #' .. count},timer.getTime()+3)
		mist.scheduleFunction(HS_isInfantryGroupInNeed,{'red','Russian Infantry Group #' .. count},timer.getTime()+4)
	end
	mist.scheduleFunction(HS_makeInfantryMove,{},timer.getTime()+1,60) -- schedule to-do-list function
end

HS_setNumberOfTroopsInCabin = function(playerName,number)
	HS_numberOfTroopsInCabin[HS_getUnitCoalition(playerName)][playerName] = number
end

HS_getNumberOfTroopsInCabin = function(playerName)
	return HS_numberOfTroopsInCabin[HS_getUnitCoalition(playerName)][playerName]
end

HS_setNumberOfRescuedPilotsInCabin = function(playerName,number)
	HS_rescuedPilotsInCabin[HS_getUnitCoalition(playerName)][playerName] = number
end

HS_getNumberOfRescuedPilotsInCabin = function(playerName)
	return HS_rescuedPilotsInCabin[HS_getUnitCoalition(playerName)][playerName]
end

HS_loading = function(coa,playerName,groupName)

	local playerUnit = HS_getUnit(playerName)
	if playerUnit and not Unit.inAir(playerUnit) then
		local group = HS_getGroup(groupName)
		if group then
			local groupSize = Group.getSize(group)
			local position = HS_getAvgPos(groupName)
			group:destroy()
			if string.sub(groupName,1,string.len('Temporary Pilot Down')) == 'Temporary Pilot Down' then
				HS_setNumberOfRescuedPilotsInCabin(playerName,HS_getNumberOfRescuedPilotsInCabin(playerName)+groupSize)
			else
				local numberOfTroopsToBeLoaded = groupSize
				if numberOfTroopsToBeLoaded > HS_humanCargo[Unit.getByName(playerName):getTypeName()]-HS_getNumberOfTroopsInCabin(playerName) then
					numberOfTroopsToBeLoaded = HS_humanCargo[Unit.getByName(playerName):getTypeName()]-HS_getNumberOfTroopsInCabin(playerName)
					HS_addInfantryGroup(coa,'Left over ' .. groupName,groupSize-numberOfTroopsToBeLoaded,position)
				end
				HS_setNumberOfTroopsInCabin(playerName,HS_getNumberOfTroopsInCabin(playerName)+numberOfTroopsToBeLoaded)
			end
			HS_out(coa,'This is ' .. playerName .. '. Troops are on board.',10)
		end
	end	
end

HS_loadTroops = function(playerGroupName)
local closestOne,distance,numberOfTroopsToBeLoaded
local country
local count

	local playerGroup = Group.getByName(playerGroupName)
	if playerGroup then
		local units = Group.getUnits(playerGroup)
		if units then
			for count = 1,#units do
				playerUnit = units[count]
				if playerUnit and not Unit.inAir(playerUnit) then
					local playerName = Unit.getName(playerUnit)
					local playerPosition = Unit.getPosition(playerUnit).p
					local coa = HS_getUnitCoalition(playerName)
					HS_out(coa,'This is ' .. playerName .. '. Request to load troops.',10)
					closestOne,distance = HS_closestInfantryGroup(coa,playerName,{'Temporary'})
					if distance > 2000 then
						HS_out(coa,'There are no friendly troops in the area',10)
					elseif closestOne then
						local startPosition = HS_getAvgPos(closestOne)
						local closestGroup = HS_getGroup(closestOne)
						local initialSize = Group.getSize(closestGroup)
						if string.sub(closestOne,1,string.len('Pilot Down')) == 'Pilot Down' then
							numberOfTroopsToBeLoaded = initialSize
						else
							numberOfTroopsToBeLoaded = HS_humanCargo[Unit.getByName(playerName):getTypeName()]-HS_getNumberOfTroopsInCabin(playerName)
						end
						if numberOfTroopsToBeLoaded > 0 then
							closestGroup:destroy()
							if numberOfTroopsToBeLoaded < initialSize then
								HS_addInfantryGroup(coa,closestOne,initialSize-numberOfTroopsToBeLoaded,startPosition)
							else
								numberOfTroopsToBeLoaded = initialSize
							end
							HS_temporaryGroupCounter = HS_temporaryGroupCounter + 1
							local temporaryName = 'Temporary ' .. closestOne .. ' # ' .. HS_temporaryGroupCounter
							HS_out(coa,'This is ' .. closestOne .. '. ' .. numberOfTroopsToBeLoaded .. ' troops are on their way.',10)
							HS_addInfantryGroup(coa,temporaryName,numberOfTroopsToBeLoaded,startPosition)
							mist.scheduleFunction(HS_moveGroupToUnit,{temporaryName,playerName,'Off Road',10},timer.getTime()+1)
							mist.scheduleFunction(HS_loading,{coa,playerName,temporaryName},timer.getTime()+mist.utils.get2DDist(startPosition,playerPosition)/3+1)
						end
					end
				end
			end
		end
	end
end

HS_offloading = function(coa,playerName,groupName,closestOne,endPosition)
local initialSize

	local playerUnit = HS_getUnit(playerName)
	if playerUnit then
		local group = HS_getGroup(groupName)
		if group then
			local groupSize = Group.getSize(group)
			group:destroy()
			local closestGroup = HS_getGroup(closestOne)
			if closestGroup then
				initialSize = Group.getSize(closestGroup)
				closestGroup:destroy()
			else
				initialSize = 0
			end
			HS_addInfantryGroup(coa,closestOne,initialSize+groupSize,endPosition)
		end
	end	
end

HS_offloadTroops = function(playerGroupName)
local airfieldName,closestOne,distance,closestOne1,distance1,closestOne2,distance2
local country,temporaryName,assaultName
local count

	local playerGroup = Group.getByName(playerGroupName)
	local units = Group.getUnits(playerGroup)
	for count = 1,#units do
		playerUnit = units[count]
		if playerUnit and not Unit.inAir(playerUnit) then
			playerName = Unit.getName(playerUnit)
			local coa = HS_getUnitCoalition(playerName)
			airfieldName,distance = HS_closestAirfield(coa,Unit.getPosition(playerUnit).p,HS_airfieldList)
			if distance < 2000 then
				for count = 1,HS_getNumberOfRescuedPilotsInCabin(playerName) do
					HS_out(coa,'Rescued pilot offloaded. Plane will respawn in 1 min.',10)
					HS_pilotCounter[coa] = HS_pilotCounter[coa] + 1
					if coa == 'blue' then
						mist.scheduleFunction(HS_flyFighterMission,{coa,'Tiger Group #' .. HS_pilotCounter[coa]},timer.getTime()+60) -- respawn rescued pilot
					else
						mist.scheduleFunction(HS_flyFighterMission,{coa,'Mig Group #' .. HS_pilotCounter[coa]},timer.getTime()+60) -- respawn rescued pilot
					end
				end
			end
			if HS_getNumberOfTroopsInCabin(playerName) > 0 then
				local playerPosition = Unit.getPosition(playerUnit).p
				closestOne1,distance1 = HS_closestInfantryGroup(coa,playerName,{'Temporary','Pilot Down'})
				closestOne2,distance2 = HS_closestInfantryGroup(HS_opponent[coa],playerName,{'Temporary','Pilot Down'})
				if distance1 < distance2 then
					distance = distance1
					closestOne = closestOne1
				else
					distance = distance2
					closestOne = closestOne2
				end
				if closestOne then
					local endPosition = HS_getAvgPos(closestOne)
					HS_out(coa,'This is ' .. playerName .. '. Offloading ' .. HS_getNumberOfTroopsInCabin(playerName) .. ' troops.',10)
					HS_temporaryGroupCounter = HS_temporaryGroupCounter + 1
					local heading = mist.getHeading(playerUnit) -- get player heading
					local startPosition = {x=playerPosition.x+20*math.cos(heading+math.pi/4),y=playerPosition.z+20*math.sin(heading+math.pi/4)}
					if coa == 'blue' then
						country = 'USA'
						temporaryName = 'Temporary US Infantry Group #' .. HS_temporaryGroupCounter
						assaultName = 'US Assault Group #' .. HS_temporaryGroupCounter
					else
						country = 'RUSSIA'
						temporaryName = 'Temporary Russian Infantry Group #' .. HS_temporaryGroupCounter
						assaultName = 'Russian Assault Group #' .. HS_temporaryGroupCounter
					end
					if distance == distance1 then
						HS_addInfantryGroup(country,temporaryName,HS_getNumberOfTroopsInCabin(playerName),startPosition)
						mist.scheduleFunction(HS_moveGroupToGroup,{temporaryName,closestOne,'Off Road',10},timer.getTime()+1)
						mist.scheduleFunction(HS_offloading,{coa,playerName,temporaryName,closestOne,endPosition},timer.getTime()+mist.utils.get2DDist(endPosition,startPosition)/3+1)
					else
						HS_addInfantryGroup(country,assaultName,HS_getNumberOfTroopsInCabin(playerName),startPosition)
						mist.scheduleFunction(HS_moveGroup,{assaultName,endPosition,'Off Road',10},timer.getTime()+1)
					end
					HS_setNumberOfTroopsInCabin(playerName,0)
				end
			end
		end
	end
end

HS_checkForFlag = function(flagName,code,arguments)
	if trigger.misc.getUserFlag(flagName) == 1 then
		trigger.action.setUserFlag(flagName,0)
		mist.scheduleFunction(code,arguments,timer.getTime()+0.1)
	end
	mist.scheduleFunction(HS_checkForFlag,{flagName,code,arguments},timer.getTime()+1)
end

HS_addRadioItem = function(playerGroupName,itemText,code,arguments)
local count

	local playerGroup = Group.getByName(playerGroupName)
	if playerGroup then
		local coa = HS_getGroupCoalition(playerGroupName)
		if not HS_menuItems[coa][playerGroupName] then
			HS_menuItems[coa][playerGroupName] = {}
		else
			for count = 1,#HS_menuItems[coa][playerGroupName] do
				if HS_menuItems[coa][playerGroupName][count].text == itemText then
					return false
				end
			end
		end
		table.insert(HS_menuItems[coa][playerGroupName],{id = Group.getID(playerGroup), text = itemText}) -- add radio item to "F10" menu
		trigger.action.addOtherCommandForGroup(Group.getID(playerGroup), itemText, coa .. itemText .. playerGroupName) -- add radio item to "F10" menu
		trigger.action.setUserFlag(coa .. itemText .. playerGroupName,0)
		mist.scheduleFunction(HS_checkForFlag,{coa .. itemText .. playerGroupName,code,arguments},timer.getTime()+1)
	end
end

HS_removeRadioItems = function(playerGroupName)
local i

	local coa = HS_getGroupCoalition(playerGroupName)
	for i =1,#menuItems[coa][playerGroupName] do
		trigger.action.removeOtherCommandForGroup(menuItems[coa][playerGroupName][i].id, menuItems[coa][playerGroupName][i].text)
	end
	menuItems[coa][playerGroupName] = {}
end

HS_closestAirfield = function (coa,playerPosition,airfieldList)
local distance
local newDistance
local i
local airfieldName
local airfieldPosition
local closestOne

	closestOne = 0
	if airfieldList[coa] then
		distance = 1000000
		for i =1,#airfieldList[coa] do -- this loop finds the airfield unit that is closest to the helo
			airfieldName = airfieldList[coa][i]
			if airfieldName then
				airfieldPosition = Airbase.getPosition(Airbase.getByName(airfieldName)).p
				newDistance = mist.utils.get2DDist(playerPosition, airfieldPosition)
				if newDistance < distance then -- is this the closest one so far
					distance = newDistance
					closestOne = i -- yes, mark it as such
				end
			end
		end
		return airfieldList[coa][closestOne],distance
	end
end

HS_findAirfieldId = function(airfieldName)
local count,ID
	ID = 0
	for count = 1,#HS_airfields do
		if HS_airfields[count].name == airfieldName then
			ID = count
			break
		end
	end
	return ID
end

HS_flyMission = function(playerGroupName,targetGroupName)
local airfieldName,distance 

	HS_groupStart(playerGroupName) -- start up engine
	local group = HS_getGroup(playerGroupName)
	if group then
		local playerName = Unit.getName(Group.getUnits(group)[1])
		local coa = HS_getUnitCoalition(playerName)
		local infantryPosition = HS_getAvgPos(targetGroupName)
		local startPoint = HS_getAvgPos(playerGroupName)
		local hoverPoint1 = mist.getRandPointInCircle(infantryPosition, 1000, 50)
		local hoverPoint2 = mist.getRandPointInCircle(startPoint, 100, 50)
		local landPoint = mist.getRandPointInCircle (infantryPosition, 1000, 50)
		airfieldName,distance = HS_closestAirfield(coa,startPoint,HS_airfieldList)
		HS_out(coa,'This is ' .. playerName .. '. Ready for take-off from ' .. airfieldName .. '. Objective is to assist ' .. targetGroupName .. '.',30)
		local airfieldId = HS_findAirfieldId(airfieldName)
		local currentTime = timer.getTime()
		if airfieldId > 0 then
			local misTask =
			{ 
				id = 'Mission', 
				params =
				{ 
					route =
					{ 
						points =
						{
							[1] = 
							{
								["alt"] = startPoint.y,
								["type"] = "TakeOffParking",
								["action"] = "From Parking Area",
								["alt_type"] = "BARO",
								["formation_template"] = "",
								["properties"] = 
								{
									["vnav"] = 1,
									["scale"] = 0,
									["angle"] = 0,
									["vangle"] = 0,
									["steer"] = 2,
								}, -- end of ["properties"]
								["ETA"] = currentTime,
								["airdromeId"] = airfieldId,
								["y"] = startPoint.z,
								["x"] = startPoint.x,
								["speed"] = 41.666666666667,
								["ETA_locked"] = true,
								["task"] = 
								{
									["id"] = "ComboTask",
									["params"] = 
									{
										["tasks"] = 
										{
										}, -- end of ["tasks"]
									}, -- end of ["params"]
								}, -- end of ["task"]
								["speed_locked"] = false,
							}, -- end of [1]
							[2] = 
							{
								["alt"] = 100,
								["type"] = "Turning Point",
								["action"] = "Turning Point",
								["alt_type"] = "RADIO",
								["formation_template"] = "",
								["properties"] = 
								{
									["vnav"] = 1,
									["scale"] = 0,
									["angle"] = 0,
									["vangle"] = 0,
									["steer"] = 2,
								}, -- end of ["properties"]
								["ETA"] = currentTime+200,
								["y"] = hoverPoint1.y,
								["x"] = hoverPoint1.x,
								["speed"] = 41.666666666667,
								["ETA_locked"] = false,
								["task"] = 
								{
									["id"] = "ComboTask",
									["params"] = 
									{
										["tasks"] = 
										{
											[1] = 
											{
												["number"] = 1,
												["auto"] = false,
												["id"] = "Land",
												["enabled"] = true,
												["params"] = 
												{
													["y"] = landPoint.y,
													["x"] = landPoint.x,
													["duration"] = 30,
													["durationFlag"] = true,
												}, -- end of ["params"]
											}, -- end of [1]
										}, -- end of ["tasks"]
									}, -- end of ["params"]
								}, -- end of ["task"]
								["speed_locked"] = true,
							}, -- end of [2]
							[3] = 
							{
								["alt"] = 100,
								["type"] = "Turning Point",
								["action"] = "Turning Point",
								["alt_type"] = "RADIO",
								["formation_template"] = "",
								["properties"] = 
								{
									["vnav"] = 1,
									["scale"] = 0,
									["angle"] = 0,
									["vangle"] = 0,
									["steer"] = 2,
								}, -- end of ["properties"]
								["ETA"] = currentTime+400,
								["y"] = hoverPoint2.y,
								["x"] = hoverPoint2.x,
								["speed"] = 41.666666666667,
								["ETA_locked"] = false,
								["task"] = 
								{
									["id"] = "ComboTask",
									["params"] = 
									{
										["tasks"] = 
										{
											[1] = 
											{
												["number"] = 1,
												["auto"] = false,
												["id"] = "Land",
												["enabled"] = true,
												["params"] = 
												{
													["y"] = startPoint.z,
													["x"] = startPoint.x,
													["duration"] = 1800,
													["durationFlag"] = true,
												}, -- end of ["params"]
											}, -- end of [1]
										}, -- end of ["tasks"]
									}, -- end of ["params"]
								}, -- end of ["task"]
								["speed_locked"] = true,
							}, -- end of [3]
						}, -- end of ["points"]
					},	
				},
			}
			local groupCon = group:getController()
			if groupCon then
				mist.scheduleFunction(Controller.pushTask,{groupCon,misTask},timer.getTime()+10) -- new task begins in 10s
			end
		end
	end
end

HS_AIhasTouchedDown = function(playerName)
local airfield,distance

	local playerUnit = HS_getUnit(playerName)
	if playerUnit then
		local playerGroup = Unit.getGroup(playerUnit)
		if playerGroup then
			local coa = HS_getUnitCoalition(playerName)
			local playerGroupName = Group.getName(playerGroup)
			airfieldName,distance = HS_closestAirfield(coa,Unit.getPosition(playerUnit).p,HS_airfieldList)
			if distance < 2000 then
				if HS_getNumberOfTroopsInCabin(playerName)+HS_getNumberOfRescuedPilotsInCabin(playerName) > 0 then
					trigger.action.setUserFlag(coa .. 'offload troops' .. playerGroupName,1)
				end
				mist.scheduleFunction(mist.respawnGroup,{playerGroupName, true},timer.getTime()+30) -- respawn helo				
				mist.scheduleFunction(Group.destroy,{playerGroup},timer.getTime()+20)			
			elseif HS_getNumberOfTroopsInCabin(playerName)+HS_getNumberOfRescuedPilotsInCabin(playerName) > 0 then
				trigger.action.setUserFlag(coa .. 'offload troops' .. playerGroupName,1)
			else
				trigger.action.setUserFlag(coa .. 'load troops' .. playerGroupName,1)
			end
		end
	end
end

HS_howManyGroupsInNeed = function(coa)
local groupName,value

	local count = 0
	for groupName,value in pairs(HS_groupsInNeed[coa]) do
		count = count+1
	end
	return count
end

HS_pickGroupInNeed = function(coa,count)
local groupName,value

	local count2 = count
	for groupName,value in pairs(HS_groupsInNeed[coa]) do
		count2 = count2-1
		if count2 == 0 then
			return groupName
		end
	end
end

HS_declareAsAI = function(playerGroupName)
local count,closestGroup,distance,closestPickUpGroup

	local group = HS_getGroup(playerGroupName)
	if group then
		local coa = HS_getGroupCoalition(playerGroupName)
		local units = Group.getUnits(group)
		closestGroup = nil
		for count = 1, #units do
			local unit = units[count]
			if unit then
				local playerName = Unit.getName(unit)
				HS_onTouchDownDo(playerName,HS_AIhasTouchedDown,{playerName})
				if not closestGroup then
					local numberOfTroopsInNeed = HS_howManyGroupsInNeed(coa)
					if numberOfTroopsInNeed > 0 then
						closestGroup = HS_pickGroupInNeed(coa,mist.random(numberOfTroopsInNeed))
					else
						closestGroup,distance = HS_closestInfantryGroup(coa,playerName,{'Airfield','Temporary','Left over'})
					end
					closestPickUpGroup,distance = HS_closestInfantryGroup(coa,playerName,{'Temporary'})
					mist.scheduleFunction(HS_flyMission,{playerGroupName,closestGroup},timer.getTime()+mist.utils.get2DDist(HS_getAvgPos(playerGroupName),HS_getAvgPos(closestPickUpGroup))/2+1)
				end
				if closestGroup then
					if string.sub(closestGroup,1,string.len('Pilot Down')) ~= 'Pilot Down' then
						trigger.action.setUserFlag(coa .. 'load troops' .. playerGroupName,1)
					end
				end
			end
		end
	end
end

HS_estimatePresentPosition = function(playerGroupName)
	local playerName = Unit.getName(Group.getUnits(Group.getByName(playerGroupName))[1])
	local outText = mist.getLLString({units = {playerName}, acc = 0, DMS = true})
	local firstmin = string.find(outText, '\'', 1)
	local string1 = string.sub(outText, 1, firstmin)
	firstmin = string.find(outText, 'N', 1)
	local string2 = string.sub(outText, firstmin)
	firstmin = string.find(string2, '\'', 1)
	string2 = string.sub(string2, 1, firstmin)
	local coa = HS_getGroupCoalition(playerGroupName)
	return string1 .. ' ' .. string2 .. ' E '
end

HS_checkForSmoke = function(coa,playerGroupName,infantryList)
local groupName,value,color,closestOne

	local timing = 0
	local newInfantryList = {}
	local playerGroup = Group.getByName(playerGroupName)
	if playerGroup then
		local playerUnits = Group.getUnits(playerGroup)
		if playerUnits then
			for count = 1,#playerUnits do
				local playerUnit = playerUnits[count]
				if playerUnit then
					local playerPosition = HS_getAvgPos(playerGroupName)
					for groupName,value in pairs(mist.DBs.groupsByName) do
						if HS_isGroupInfantry(groupName) and coa == HS_getGroupCoalition(groupName) and string.sub(groupName,1,string.len('Temporary')) ~= 'Temporary' then
							local infantryPosition = HS_getAvgPos(groupName)
							if playerPosition and infantryPosition and mist.utils.get2DDist(playerPosition, infantryPosition) < 5000 then
								if not infantryList[groupName] then
									newInfantryList[groupName] = 1
									if coa == 'blue' then
										color = 4
									else
										color = 1
									end
									timing = timing + 5
									mist.scheduleFunction(HS_out,{coa,Unit.getName(playerUnit) .. ', this is ' .. groupName .. '. Popping smoke',10},timer.getTime()+timing)
									mist.scheduleFunction(trigger.action.smoke,{infantryPosition, color},timer.getTime()+timing)
									closestOne,distance = HS_closestInfantryGroup(HS_opponent[coa],Unit.getName(Group.getUnits(Group.getByName(groupName))[1]))
									if distance < 5000 then
										local enemyInfantryPosition = HS_getAvgPos(closestOne)
										local heading = HS_getHeading(enemyInfantryPosition,infantryPosition)
										mist.scheduleFunction(HS_out,{coa, 'The enemy is at a distance of ' .. math.floor((mist.utils.get2DDist(enemyInfantryPosition,infantryPosition)+50)/100)*100 .. ' meters, heading ' .. heading .. ' from our position.',10},timer.getTime()+timing+1)
									end
								else
									newInfantryList[groupName] = infantryList[groupName]+1
									if newInfantryList[groupName] > 10 then
										newInfantryList[groupName] = nil
									end
								end
							end
						end
					end
					break
				end
			end
		end
		mist.scheduleFunction(HS_checkForSmoke,{coa,playerGroupName,newInfantryList},timer.getTime()+30)
	end
end

HS_addCheckForSmoke = function(playerGroupName)
	local playerGroup = Group.getByName(playerGroupName)
	if playerGroup then
		local coa = HS_getGroupCoalition(playerGroupName)
		if HS_checkForSmokeList[coa][playerGroupName] then
			return false
		end
		HS_checkForSmokeList[coa][playerGroupName] = true
		mist.scheduleFunction(HS_checkForSmoke,{coa,playerGroupName,{}},timer.getTime()+30)
	end
end

HS_checkForFlare = function(coa,playerGroupName,infantryList)
local groupName,value,color,closestOne

	local timing = 0
	local newInfantryList = {}
	local playerGroup = Group.getByName(playerGroupName)
	if playerGroup then
		local playerUnits = Group.getUnits(playerGroup)
		if playerUnits then
			for count = 1,#playerUnits do
				local playerUnit = playerUnits[count]
				if playerUnit then
					local playerPosition = HS_getAvgPos(playerGroupName)
					for groupName,value in pairs(mist.DBs.groupsByName) do
						if HS_isGroupInfantry(groupName) and coa == HS_getGroupCoalition(groupName) and string.sub(groupName,1,string.len('Temporary')) ~= 'Temporary' then
							local infantryPosition = HS_getAvgPos(groupName)
							if playerPosition and infantryPosition and mist.utils.get2DDist(playerPosition, infantryPosition) < 5000 then
								if not infantryList[groupName] then
									newInfantryList[groupName] = 1
									if coa == 'blue' then
										color = 3
									else
										color = 1
									end
									timing = timing + 5
									mist.scheduleFunction(HS_out,{coa,Unit.getName(playerUnit) .. ', this is ' .. groupName .. '. Popping flare',10},timer.getTime()+timing)
									mist.scheduleFunction(trigger.action.signalFlare,{infantryPosition, color,0},timer.getTime()+timing)
									closestOne,distance = HS_closestInfantryGroup(HS_opponent[coa],Unit.getName(Group.getUnits(Group.getByName(groupName))[1]))
									if distance < 5000 then
										local enemyInfantryPosition = HS_getAvgPos(closestOne)
										local heading = HS_getHeading(enemyInfantryPosition,infantryPosition)
										mist.scheduleFunction(HS_out,{coa, 'The enemy is at a distance of ' .. math.floor((mist.utils.get2DDist(enemyInfantryPosition,infantryPosition)+50)/100)*100 .. ' meters, heading ' .. heading .. ' from our position.',10},timer.getTime()+timing+1)
									end
								else
									newInfantryList[groupName] = infantryList[groupName]+1
									if newInfantryList[groupName] > 10 then
										newInfantryList[groupName] = nil
									end
								end
							end
						end
					end
					break
				end
			end
		end
		mist.scheduleFunction(HS_checkForFlare,{coa,playerGroupName,newInfantryList},timer.getTime()+30)
	end
end

HS_addCheckForFlare = function(playerGroupName)
	local playerGroup = Group.getByName(playerGroupName)
	if playerGroup then
		local coa = HS_getGroupCoalition(playerGroupName)
		if HS_checkForFlareList[coa][playerGroupName] then
			return false
		end
		HS_checkForFlareList[coa][playerGroupName] = true
		mist.scheduleFunction(HS_checkForFlare,{coa,playerGroupName,{}},timer.getTime()+30)
	end
end

HS_generateAirDefence = function(coa,number,zone)
local i
local unitType,country

	if coa == 'red' then
		unitType = 'ZU-23 Emplacement Closed'
		country = 'RUSSIA'
	else
		unitType = 'Vulcan'
		country = 'USA'
	end
	
	local units = {}
	for i =1,number do
		local unitPosition = mist.getRandPointInCircle(mist.utils.zoneToVec3(zone),mist.DBs.zonesByName[zone].radius) -- get random position for individual unit
		table.insert(units,
		{
			["x"] = unitPosition.x,
			["y"] = unitPosition.y,
			["type"] = unitType,
			["name"] = coa .. ' AAA Unit #' .. i,
			["heading"] = 0,
			["skill"] = "Random"
		})
	end
	mist.dynAdd({country = country, category = 'GROUND_UNIT', name = coa .. ' AAA Group', hidden = false, units = units })

	if coa == 'red' then
		unitType = 'SA-18 Igla-S manpad'
	else
		unitType = 'Stinger manpad'
	end

	units = {}
	for i =1,number do
		local unitPosition = mist.getRandPointInCircle(mist.utils.zoneToVec3(zone),mist.DBs.zonesByName[zone].radius) -- get random position for individual unit
		table.insert(units,
		{
			["x"] = unitPosition.x,
			["y"] = unitPosition.y,
			["type"] = unitType,
			["name"] = coa .. 'MANPADS Unit #' .. i,
			["heading"] = 0,
			["skill"] = "Average"
		})
	end
	mist.dynAdd({country = country, category = 'GROUND_UNIT', name = coa .. 'MANPADS Group', hidden = false, units = units })
end

HS_incoming = function(coa,event) -- this is the main routine, coa contains the name of the coalition that was targeted by the missile
local key,value

	local weapon = event.weapon
	if Weapon.isExist(weapon) then
		for playerName,value in pairs(HS_checkForIncomingList[coa]) do -- loop of all client helicopter in the mission that belong to the target coalition
			local playerUnit = Unit.getByName(playerName) -- get unit
			if playerUnit then -- is unit alive?
				local position = Weapon.getPosition(weapon).p -- get position of missile
				local playerPosition = Unit.getPosition(playerUnit).p -- get position of helicopter
				local relativePosition = mist.vec.sub(position,playerPosition)
				if mist.vec.mag(relativePosition) < HS_detectionRange then -- was the missile launch within the detection range?
					local playerHeading = mist.getHeading(Unit.getByName(playerName)) -- the rest of the code determines the 'o'clock' bearing of the missile relative to the helicopter
					local headingVector = {x = math.cos(playerHeading),y=0,z=math.sin(playerHeading)}
					local headingVectorPerpendicular = {x = math.cos(playerHeading+math.pi/2),y=0,z=math.sin(playerHeading+math.pi/2)}
					local forwardDistance = mist.vec.dp(relativePosition,headingVector)
					local rightDistance = mist.vec.dp(relativePosition,headingVectorPerpendicular)
					local angle = math.atan2(rightDistance,forwardDistance)*180/math.pi
					if angle < 0 then
						angle = 360+angle
					end
					angle = math.floor(angle*12/360+0.5)
					if angle == 0 then
						angle = 12
					end
					local text = '[copilot] Incoming ' .. angle .. ' oclock'
					HS_INCOM_outUnit(playerName,text,1) -- output warning text and audio
				end
			end
		end
		mist.scheduleFunction(HS_incoming,{coa,event},timer.getTime()+1) -- next warning will occur in 1 second
	end
end

HS_addCheckForIncoming = function(playerName)
	local coa = HS_getUnitCoalition(playerName)
	if HS_checkForIncomingList[coa][playerName] then
		return false
	end
	HS_checkForIncomingList[coa][playerName] = true
	return true
end

HS_hoverGuidance = function(playerName,hoverPoints)
local count
local minCount

	local playerUnit = Unit.getByName(playerName)
	if playerUnit then
		local groupId = Group.getID(Unit.getGroup(playerUnit))
		local playerPosition = Unit.getPosition(playerUnit).p -- position of helicopter pilot
		local coa = HS_getUnitCoalition(playerName)
		local landHeight = land.getHeight(mist.utils.makeVec2(playerPosition)) -- get altitude of ground
		local minDistance = nil
		for count = 1,#hoverPoints[coa] do -- which of the hover points is closest to the chopper pilot
			if not minDistance or mist.utils.get2DDist(playerPosition,hoverPoints[coa][count].position) < minDistance then
				minCount = count
				minDistance = mist.utils.get2DDist(playerPosition,hoverPoints[coa][count].position)
			end
		end -- no we have found which is closest
		if minDistance then
			local hoverPoint = hoverPoints[coa][minCount] --  hoverPoint is closest hovering point
			local hoverPosition = hoverPoint.position -- location of the hover point
			local playerHeading = math.atan2(Unit.getPosition(playerUnit).x.z,Unit.getPosition(playerUnit).x.x) -- beginning of code that determines crew chief instructions
			local headingVector = {x = math.cos(playerHeading),y=0,z=math.sin(playerHeading)}
			local headingVectorPerpendicular = {x = -math.sin(playerHeading),y=0,z=math.cos(playerHeading)}
			local relativePosition = mist.vec.sub(hoverPosition,playerPosition)
			local forwardDistance = mist.vec.dp(relativePosition,headingVector)
			local rightDistance = mist.vec.dp(relativePosition,headingVectorPerpendicular)
			local distance = math.sqrt(forwardDistance*forwardDistance+rightDistance*rightDistance) -- beginning of code that determines crew chief instructions
			if distance < hoverPoint.minD then
				hoverPoints[coa][minCount].duration = hoverPoints[coa][minCount].duration+2
			elseif distance > hoverPoint.minD and distance < hoverPoint.maxD then -- are we in the distance range where we want crew chief instructions?
				hoverPoints[coa][minCount].duration = 0
				if math.abs(forwardDistance) > math.abs(rightDistance) then -- now output the appropriate instructions
					trigger.action.outTextForGroup(groupId,math.floor(math.abs(forwardDistance)) .. 'm',2)
					if forwardDistance > 0 then
						trigger.action.outSoundForGroup(groupId,HS_forwardSound)
					else
						trigger.action.outSoundForGroup(groupId,HS_backSound)
					end
				else
					trigger.action.outTextForGroup(groupId,math.floor(math.abs(rightDistance)) .. 'm',2)
					if rightDistance > 0 then
						trigger.action.outSoundForGroup(groupId,HS_rightSound)
					else
						trigger.action.outSoundForGroup(groupId,HS_leftSound)
					end
				end
			end
			if distance < hoverPoint.maxD then
				if playerPosition.y > landHeight + hoverPoint.maxH then
					hoverPoints[coa][minCount].duration = 0
					mist.scheduleFunction(trigger.action.outSoundForGroup,{groupId,HS_downSound},timer.getTime()+1)
				elseif playerPosition.y < landHeight + hoverPoint.minH then
					hoverPoints[coa][minCount].duration = 0
					mist.scheduleFunction(trigger.action.outSoundForGroup,{groupId,HS_upSound},timer.getTime()+1)
				end
			end
		end
		if hoverPoints[coa][minCount].duration > 10 and not HS_slingLoad[coa][playerName] then
			HS_slingLoad[coa][playerName] = true
			HS_out(coa,playerName .. ', sling load has been successfully attached.',10)
		end
		mist.scheduleFunction(HS_hoverGuidance,{playerName,hoverPoints},timer.getTime()+2) -- start this function for each unitName you want the hover guidance, will be run every 2 seconds
	end
end

HS_addHoverGuidance = function(playerName,hoverPoints)
	mist.scheduleFunction(HS_hoverGuidance,{playerName,hoverPoints},timer.getTime()+1) -- start this function for each unitName you want the hover guidance, will be run every 2 seconds
end

HS_fighterHasTouchedDown = function(coa,groupName)
	HS_getGroup(groupName):destroy()
	HS_flyFighterMission(coa,groupName)
end

HS_flyFighterMission = function(coa,groupName)
local count

	local airfield = HS_airfieldList[coa][mist.random(#HS_airfieldList[coa])]
	local airfieldId = HS_findAirfieldId(airfield)
	local airbase = Airbase.getByName(airfield)
	if airbase then
		local position = Airbase.getPosition(airbase).p
		local waypoints = {}
		local points = {}
		local currentTime = timer.getTime()
		for count = 1,6 do
			waypoints[count] = mist.getRandPointInCircle(mist.utils.zoneToVec3 ('Air Battle Zone'),mist.DBs.zonesByName['Air Battle Zone'].radius)
			table.insert(points,{
									["alt"] = 6096,
									["type"] = "Turning Point",
									["action"] = "Turning Point",
									["alt_type"] = "BARO",
									["formation_template"] = "",
									["properties"] = 
									{
										["vnav"] = 1,
										["scale"] = 0,
										["angle"] = 0,
										["vangle"] = 0,
										["steer"] = 2,
									}, -- end of ["properties"]
									["ETA"] = currentTime+(count-1)*100,
									["y"] = waypoints[count].y,
									["x"] = waypoints[count].x,
									["speed"] = 138.88888888889,
									["ETA_locked"] = false,
									["task"] = 
									{
										["id"] = "ComboTask",
										["params"] = 
										{
											["tasks"] = 
											{
											}, -- end of ["tasks"]
										}, -- end of ["params"]
									}, -- end of ["task"]
									["speed_locked"] = true,
								})
		end
		points[1] = {
						["alt"] = 0,
						["type"] = "TakeOffParking",
						["action"] = "From Parking Area",
						["alt_type"] = "RADAR",
						["formation_template"] = "",
						["properties"] = 
						{
							["vnav"] = 1,
							["scale"] = 0,
							["angle"] = 0,
							["vangle"] = 0,
							["steer"] = 2,
						}, -- end of ["properties"]
						["ETA"] = currentTime,
						["airdromeId"] = airfieldId,
						["y"] = position.z,
						["x"] = position.x,
						["speed"] = 0,
						["ETA_locked"] = true,
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
									[1] = 
									{
										["number"] = 1,
										["auto"] = true,
										["id"] = "EngageTargets",
										["enabled"] = true,
										["key"] = "CAP",
										["params"] = 
										{
											["targetTypes"] = 
											{
												[1] = "Air",
											}, -- end of ["targetTypes"]
											["priority"] = 0,
										}, -- end of ["params"]
									}, -- end of [1]
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["speed_locked"] = true,
					}
		points[6] = {
						["alt"] = 6096,
						["type"] = "Turning Point",
						["action"] = "Turning Point",
						["alt_type"] = "BARO",
						["formation_template"] = "",
						["properties"] = 
						{
							["vnav"] = 1,
							["scale"] = 0,
							["angle"] = 0,
							["vangle"] = 0,
							["steer"] = 2,
						}, -- end of ["properties"]
						["ETA"] = currentTime + 500,
						["y"] = waypoints[6].y,
						["x"] = waypoints[6].x,
						["speed"] = 154.16666666667,
						["ETA_locked"] = false,
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
									[1] = 
									{
										["enabled"] = true,
										["auto"] = false,
										["id"] = "WrappedAction",
										["number"] = 1,
										["params"] = 
										{
											["action"] = 
											{
												["id"] = "SwitchWaypoint",
												["params"] = 
												{
													["goToWaypointIndex"] = 3,
													["fromWaypointIndex"] = 6,
												}, -- end of ["params"]
											}, -- end of ["action"]
										}, -- end of ["params"]
									}, -- end of [1]
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["speed_locked"] = true,
					}
		if coa == 'blue' then
			HS_pilotCounter[coa] = HS_pilotCounter[coa]+1
			local unitName = 'Enfield' .. HS_pilotCounter[coa] .. '1 (Fighter)'
			mist.scheduleFunction(mist.dynAdd,{{country = 'USA', category = 'AIRPLANE', 
				["modulation"] = 0,
				["radioSet"] = false,
				["task"] = "CAP",
				["uncontrolled"] = false,
				["taskSelected"] = true,
				["route"] = 
				{
					["points"] = points
				}, -- end of ["route"]
				["hidden"] = false,
				["units"] = 
				{
					[1] = 
					{
						["alt"] = 0,
						["alt_type"] = "RADAR",
						["livery_id"] = "`green` paint scheme",
						["skill"] = "Random",
						["speed"] = 0,
						["type"] = "F-5E",
						["unitId"] = 1,
						["psi"] = 1.4896291831607,
						["y"] = position.z,
						["x"] = position.x,
						["name"] = unitName,
						["payload"] = 
						{
							["pylons"] = 
							{
								[1] = 
								{
									["CLSID"] = "{6CEB49FC-DED8-4DED-B053-E1F033FF72D3}",
								}, -- end of [1]
								[2] = 
								{
									["CLSID"] = "{6CEB49FC-DED8-4DED-B053-E1F033FF72D3}",
								}, -- end of [2]
								[4] = 
								{
									["CLSID"] = "{0395076D-2F77-4420-9D33-087A4398130B}",
								}, -- end of [4]
								[6] = 
								{
									["CLSID"] = "{6CEB49FC-DED8-4DED-B053-E1F033FF72D3}",
								}, -- end of [6]
								[7] = 
								{
									["CLSID"] = "{6CEB49FC-DED8-4DED-B053-E1F033FF72D3}",
								}, -- end of [7]
							}, -- end of ["pylons"]
							["fuel"] = "2000",
							["flare"] = 15,
							["chaff"] = 30,
							["gun"] = 100,
						}, -- end of ["payload"]
						["heading"] = -1.4896291831607,
						["callsign"] = 
						{
							[1] = 1,
							[2] = HS_pilotCounter[coa],
							[3] = 1,
							["name"] = 'Enfield' .. HS_pilotCounter[coa] .. '1',
						}, -- end of ["callsign"]
						["onboard_num"] = '1' .. HS_pilotCounter[coa],
					}, -- end of [1]
				}, -- end of ["units"]
				["y"] = position.z,
				["x"] = position.x,
				["name"] = groupName,
				["communication"] = true,
				["start_time"] = 0,
				["frequency"] = 124,
			}},timer.getTime()+1)
			mist.scheduleFunction(HS_onTouchDownDo,{unitName,HS_fighterHasTouchedDown,{coa,groupName}},timer.getTime()+2)
		else
			HS_pilotCounter[coa] = HS_pilotCounter[coa]+1
			local unitName = '' .. 500+HS_pilotCounter[coa] .. ' (Fighter)'
			mist.scheduleFunction(mist.dynAdd,{{country = 'RUSSIA', category = 'AIRPLANE', 
				["modulation"] = 0,
				["radioSet"] = false,
				["task"] = "CAP",
				["uncontrolled"] = false,
				["taskSelected"] = true,
				["route"] = 
				{
					["points"] = points, -- end of ["points"]
				}, -- end of ["route"]
				["hidden"] = false,
				["units"] = 
				{
					[1] = 
					{
						["alt"] = 0,
						["alt_type"] = "RADAR",
						["livery_id"] = "af standard",
						["skill"] = "Random",
						["speed"] = 0,
						["type"] = "MiG-23MLD",
						["unitId"] = 1,
						["psi"] = 1.4896291831607,
						["y"] = position.z,
						["x"] = position.x,
						["name"] = unitName,
						["payload"] = 
						{
							["pylons"] = 
							{
								[3] = 
								{
									["CLSID"] = "{B0DBC591-0F52-4F7D-AD7B-51E67725FB81}",
								}, -- end of [3]
								[4] = 
								{
									["CLSID"] = "{A5BAEAB7-6FAF-4236-AF72-0FD900F493F9}",
								}, -- end of [4]
								[5] = 
								{
									["CLSID"] = "{275A2855-4A79-4B2D-B082-91EA2ADF4691}",
								}, -- end of [5]
							}, -- end of ["pylons"]
							["fuel"] = "3800",
							["flare"] = 60,
							["chaff"] = 60,
							["gun"] = 100,
						}, -- end of ["payload"]
						["heading"] = -1.4896291831607,
						["callsign"] = 500+HS_pilotCounter[coa],
						["onboard_num"] = '1' .. HS_pilotCounter[coa],
					}, -- end of [1]
				}, -- end of ["units"]
				["y"] = position.z,
				["x"] = position.x,
				["name"] = groupName,
				["communication"] = true,
				["start_time"] = 0,
				["frequency"] = 124,
			}},timer.getTime()+1)
			mist.scheduleFunction(HS_onTouchDownDo,{unitName,HS_fighterHasTouchedDown,{coa,groupName}},timer.getTime()+2)
		end
	end
end

HS_flyHelicopterSEADMission = function(coa,groupName)
local count,zone

	local airfield = HS_airfieldList[coa][mist.random(#HS_airfieldList[coa])]
	local airfieldId = HS_findAirfieldId(airfield)
	local airbase = Airbase.getByName(airfield)
	if coa == 'blue' then
		zone = 'Russian AAA Zone'
	else
		zone = 'US AAA Zone'
	end
	if airbase then
		local position = Airbase.getPosition(airbase).p
		local waypoints = {}
		local points = {}
		local currentTime = timer.getTime()
		for count = 1,6 do
			waypoints[count] = mist.getRandPointInCircle(mist.utils.zoneToVec3(zone),mist.DBs.zonesByName[zone].radius)
			table.insert(points,{
									["alt"] = 150,
									["type"] = "Turning Point",
									["action"] = "Turning Point",
									["alt_type"] = "RADAR",
									["formation_template"] = "",
									["properties"] = 
									{
										["vnav"] = 1,
										["scale"] = 0,
										["angle"] = 0,
										["vangle"] = 0,
										["steer"] = 2,
									}, -- end of ["properties"]
									["ETA"] = currentTime+(count-1)*200,
									["y"] = waypoints[count].y,
									["x"] = waypoints[count].x,
									["speed"] = 70,
									["ETA_locked"] = false,
									["task"] = 
									{
										["id"] = "ComboTask",
										["params"] = 
										{
											["tasks"] = 
											{
											}, -- end of ["tasks"]
										}, -- end of ["params"]
									}, -- end of ["task"]
									["speed_locked"] = true,
								})
		end
		points[1] = {
						["alt"] = 0,
						["type"] = "TakeOffParking",
						["action"] = "From Parking Area",
						["alt_type"] = "RADAR",
						["formation_template"] = "",
						["properties"] = 
						{
							["vnav"] = 1,
							["scale"] = 0,
							["angle"] = 0,
							["vangle"] = 0,
							["steer"] = 2,
						}, -- end of ["properties"]
						["ETA"] = currentTime,
						["airdromeId"] = airfieldId,
						["y"] = position.z,
						["x"] = position.x,
						["speed"] = 0,
						["ETA_locked"] = true,
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
									[1] = 
									{
										["number"] = 1,
										["auto"] = false,
										["id"] = "EngageTargets",
										["enabled"] = true,
										["params"] = 
										{
											["targetTypes"] = 
											{
												[1] = "Air Defence",
											}, -- end of ["targetTypes"]
											["maxDistEnabled"] = false,
											["priority"] = 0,
											["maxDist"] = 15000,
										}, -- end of ["params"]
									}, -- end of [1]
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["speed_locked"] = true,
					}
		points[6] = {
						["alt"] = 150,
						["type"] = "Turning Point",
						["action"] = "Turning Point",
						["alt_type"] = "RADAR",
						["formation_template"] = "",
						["properties"] = 
						{
							["vnav"] = 1,
							["scale"] = 0,
							["angle"] = 0,
							["vangle"] = 0,
							["steer"] = 2,
						}, -- end of ["properties"]
						["ETA"] = currentTime + 1000,
						["y"] = waypoints[6].y,
						["x"] = waypoints[6].x,
						["speed"] = 70,
						["ETA_locked"] = false,
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
									[1] = 
									{
										["enabled"] = true,
										["auto"] = false,
										["id"] = "WrappedAction",
										["number"] = 1,
										["params"] = 
										{
											["action"] = 
											{
												["id"] = "SwitchWaypoint",
												["params"] = 
												{
													["goToWaypointIndex"] = 3,
													["fromWaypointIndex"] = 6,
												}, -- end of ["params"]
											}, -- end of ["action"]
										}, -- end of ["params"]
									}, -- end of [1]
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["speed_locked"] = true,
					}
		if coa == 'blue' then
			HS_pilotCounter[coa] = HS_pilotCounter[coa]+1
			local unitName = 'Uzi' .. HS_pilotCounter[coa] .. '1 (helicopter SEAD)'
			mist.scheduleFunction(mist.dynAdd,{{country = 'USA', category = 'helicopter', 
				["modulation"] = 0,
				["radioSet"] = false,
				["task"] = "CAS",
				["uncontrolled"] = false,
				["taskSelected"] = true,
				["route"] = 
				{
					["points"] = points
				}, -- end of ["route"]
				["hidden"] = false,
				["units"] = 
				{
					[1] = 
					{
						["alt"] = 0,
						["hardpoint_racks"] = true,
						["alt_type"] = "RADAR",
						["livery_id"] = "USA X Black",
						["skill"] = "Random",
						["speed"] = 0,
						["type"] = "AH-1W",
						["unitId"] = 1,
						["psi"] = -0.14747899115982,
						["y"] = position.z,
						["x"] = position.x,
						["name"] = unitName,
						["payload"] = 
						{
							["pylons"] = 
							{
								[1] = 
								{
									["CLSID"] = "{88D18A5E-99C8-4B04-B40B-1C02F2018B6E}",
								}, -- end of [1]
								[4] = 
								{
									["CLSID"] = "{88D18A5E-99C8-4B04-B40B-1C02F2018B6E}",
								}, -- end of [4]
							}, -- end of ["pylons"]
							["fuel"] = 1125,
							["flare"] = 30,
							["chaff"] = 30,
							["gun"] = 100,
						}, -- end of ["payload"]
						["heading"] = 0,
						["callsign"] = 
						{
							[1] = 3,
							[2] = HS_pilotCounter[coa],
							[3] = 1,
							["name"] = 'Uzi ' .. HS_pilotCounter[coa] .. '-1',
						}, -- end of ["callsign"]
						["onboard_num"] = "050",
					}, -- end of [1]
				}, -- end of ["units"]
				["y"] = position.z,
				["x"] = position.x,
				["name"] = groupName,
				["communication"] = true,
				["start_time"] = 0,
				["frequency"] = 124,
			}},timer.getTime()+1)
			mist.scheduleFunction(HS_onTouchDownDo,{unitName,HS_fighterHasTouchedDown,{coa,groupName}},timer.getTime()+2)
		else
			HS_pilotCounter[coa] = HS_pilotCounter[coa]+1
			local unitName = '' .. 600+HS_pilotCounter[coa] .. ' (helicopter SEAD)'
			mist.scheduleFunction(mist.dynAdd,{{country = 'RUSSIA', category = 'helicopter', 
				["modulation"] = 0,
				["radioSet"] = false,
				["task"] = "CAS",
				["uncontrolled"] = false,
				["taskSelected"] = true,
				["route"] = 
				{
					["points"] = points, -- end of ["points"]
				}, -- end of ["route"]
				["hidden"] = false,
				["units"] = 
				{
					[1] = 
					{
						["alt"] = 0,
						["hardpoint_racks"] = true,
						["alt_type"] = "RADAR",
						["livery_id"] = "standard 1",
						["skill"] = "Random",
						["speed"] = 0,
						["type"] = "Mi-24V",
						["unitId"] = 1,
						["psi"] = -0.14747899115987,
						["y"] = position.z,
						["x"] = position.x,
						["name"] = unitName,
						["payload"] = 
						{
							["pylons"] = 
							{
								[3] = 
								{
									["CLSID"] = "{FC56DF80-9B09-44C5-8976-DCFAFF219062}",
								}, -- end of [3]
								[4] = 
								{
									["CLSID"] = "{FC56DF80-9B09-44C5-8976-DCFAFF219062}",
								}, -- end of [4]
							}, -- end of ["pylons"]
							["fuel"] = 1363,
							["flare"] = 192,
							["chaff"] = 0,
							["gun"] = 100,
						}, -- end of ["payload"]
						["heading"] = 0,
						["callsign"] = 600+HS_pilotCounter[coa],
						["onboard_num"] = "050",
					}, -- end of [1]
				}, -- end of ["units"]
				["y"] = position.z,
				["x"] = position.x,
				["name"] = groupName,
				["communication"] = true,
				["start_time"] = 0,
				["frequency"] = 124,
			}},timer.getTime()+1)
			mist.scheduleFunction(HS_onTouchDownDo,{unitName,HS_fighterHasTouchedDown,{coa,groupName}},timer.getTime()+2)
		end
	end
end

HS_pilotDown = function(event) -- there is a pilot down
	local pilotUnit = event.initiator
	if pilotUnit then
		local coa = HS_getUnitCoalition(pilotUnit)
		HS_pilotDownCounter[coa] = HS_pilotDownCounter[coa]+1
		local groupName = 'Pilot Down ' .. coa .. ' Group #' .. HS_pilotDownCounter[coa]
		HS_addInfantryGroup(coa,groupName,1, mist.vec.add(Unit.getPosition(pilotUnit).p,{x=100,y=0,z=100}))
		HS_groupsInNeed[coa][groupName] = true
		HS_out(coa,'To all units. We have a pilot down.',10)
	end
end

HS_reportIAS = function(playerName,oldSpeed,oldHeading,oldTime)
local headingText

	local speed = 0
	local heading = 0
	local unit = Unit.getByName(playerName)
	local currentTime = oldTime
	if unit then
		local playerPosition = Unit.getPosition(unit).p
		local landHeight = land.getHeight({x=playerPosition.x,y=playerPosition.z})
		if playerPosition.y > landHeight+10 then
			heading = math.floor((mist.getHeading(unit)*180/math.pi+5)/10)*10
			if heading < 100 then
				headingText = '0' .. heading
			else
				headingText = '' .. heading
			end
			if headingText == '00' then
				headingText = '360'
			end
			local velocity = Unit.getVelocity(unit) -- let's get its velocity
			local wind = atmosphere.getWind(playerPosition)
			local relativeVelocity = mist.vec.sub(velocity,wind)
			speed = math.sqrt(relativeVelocity.x^2+relativeVelocity.z^2)  -- calculate its speed
			if speed > 10 and (math.abs(speed - oldSpeed) > 2.5 or math.abs(heading-oldHeading) > 10 or timer.getTime() - oldTime > 60) then
				trigger.action.outSoundForCoalition(coalition.side.BLUE,HS_radioStatic)
				trigger.action.outTextForCoalition(coalition.side.BLUE,'This is ' ..  playerName .. '. ' .. math.floor(((1-6E-5*playerPosition.y)*speed*1.944+2.5)/5)*5 .. ' kts indicated, heading ' .. headingText .. '. ',20)
				currentTime = timer.getTime()
			end
		end
		mist.scheduleFunction(HS_reportIAS,{playerName,speed,heading,currentTime},timer.getTime() + 3)
	end
end

HS_addReportIAS = function(playerName)
	mist.scheduleFunction(HS_reportIAS,{playerName,0,0,timer.getTime()},timer.getTime() + 3)
end

local function customEventHandler(event)
	if event.id == world.event.S_EVENT_EJECTION then
		HS_pilotDown(event)
	end

	if HS_casualtyReport then
		local text = ''
		if event.initiator then
			local playerName = Unit.getName(event.initiator)
			if playerName then
				if event.id == 2 then
					text = 'This ' .. playerName .. ' we are taking hits.'
				elseif event.id == 8 then
					text = 'This ' .. playerName .. ' we are taking casualties.'
				elseif event.id == 22 then
					text = 'This ' .. playerName .. '. We have opened fire.'
				end
				if text ~= '' then
					if HS_getUnitCoalition(playerName) == 'blue' then
						trigger.action.outSoundForCoalition(coalition.side.BLUE,HS_radioStatic)
						trigger.action.outTextForCoalition(coalition.side.BLUE,text,3)
					else
						trigger.action.outSoundForCoalition(coalition.side.RED,HS_radioStatic)
						trigger.action.outTextForCoalition(coalition.side.RED,text,3)
					end
				end
			end
		end
	end

-- BEGIN: ADD THIS TO YOUR EVENT HANDLER
	if event.id == world.event.S_EVENT_SHOT then -- was there a weapons launch by one of the SAM sites? 
		if event.initiator then
			mist.scheduleFunction(HS_incoming,{HS_opponent[HS_getUnitCoalition(event.initiator)],event},timer.getTime() + HS_reactionTime) -- warning will be given after reactionTime seconds
		end
	end
-- END: ADD THIS TO YOUR EVENT HANDLER
end

HS_initializeFARP = function(FARPname)
local count2,country
local FARPunits = {blue = {"M978 HEMTT Tanker","M978 HEMTT Tanker","M978 HEMTT Tanker","Hummer","M 818","M1043 HMMWV Armament","M48 Chaparral","M48 Chaparral"} , red = {"ATMZ-5","ATMZ-5","Ural-375 PBU","Ural-375 PBU","Ural-375 PBU","Ural-375","Strela-1 9P31","Strela-1 9P31"}}local unitCount

	local position = mist.DBs.unitsByName[FARPname].point
	local coa = mist.DBs.unitsByName[FARPname].coalition
	local units = {}
	for count2 = 1,#FARPunits[coa] do
		table.insert(units,	{
								["type"] = FARPunits[coa][count2],
								["name"] = FARPname .. ' Unit #' .. count2,
								["heading"] = 0,
								["skill"] = "Random",
								["x"] = position.x - 100,
								["y"] = position.y + 100 - 20*count2,
							})
	end
	if coa == 'blue' then
		mist.dynAdd({country = 'USA', category = 'GROUND_UNIT', name = FARPname .. ' Vehicle Group', hidden = false, units = units})
	else
		mist.dynAdd({country = 'RUSSIA', category = 'GROUND_UNIT', name = FARPname .. ' Vehicle Group', hidden = false, units = units})
	end

	if coa == 'blue' then
		country = 'USA'
	else
		country = 'RUSSIA'
	end
	
	local static1 = {
		country = country,
		category = "Fortifications",
		x = position.x + 100-20,
		y = position.y - 100,
		type = "FARP Ammo Dump Coating",
		name = FARPname .. ' Ammo Depot',
	}
	 
	local static2 = {
		country = country,
		category = "Fortifications",
		x = position.x + 100-40,
		y = position.y - 100,
		type = "FARP CP Blindage",
		name = FARPname .. ' Building',
	}
	 
	local static3 = {
		country = country,
		category = "Fortifications",
		x = position.x + 100-60,
		y = position.y - 100,
		type = "FARP Fuel Depot",
		name = FARPname .. ' Fuel Depot',
	}
	mist.dynAddStatic(static1) 
	mist.dynAddStatic(static2) 
	mist.dynAddStatic(static3) 
end

HS_clearADFlist = function(coa)
local count
	
	for count = 1,#HS_ADFlist[coa] do
		local entry = HS_ADFlist[coa]
		if entry.group then
			local groupName = entry.group
			local group = HS_getGroup(groupName)
			if group then
				HS_stopTransmission(groupName)
			end
			HS_ADFlist[coa].group = nil
		end
	end
end

HS_removeADF = function(coa,groupName)
local count
	
	for count = 1,#HS_ADFlist[coa] do
		local entry = HS_ADFlist[coa]
		if entry.group and entry.group == groupName then
			local groupName = entry.group
			local group = HS_getGroup(groupName)
			if group then
				HS_stopTransmission(groupName)
			end
			HS_ADFlist[coa].group = nil
		end
	end
end

HS_assignADF = function(coa,groupName)
local count
	
	for count = 1,#HS_ADFlist[coa] do
		local entry = HS_ADFlist[coa][count]
		if entry.group and entry.group == groupName then
			HS_stopTransmission(groupName)
			mist.scheduleFunction(HS_groupSetADF,{groupName,entry.frequency,entry.modulation},timer.getTime()+1)
			mist.scheduleFunction(HS_startTransmission,{groupName},timer.getTime()+2)
			HS_ADFlist[coa].group = groupName
			return entry.name
		end
	end

	for count = 1,#HS_ADFlist[coa] do
		local entry = HS_ADFlist[coa][count]
		if not entry.group then
			mist.scheduleFunction(HS_groupSetADF,{groupName,entry.frequency,entry.modulation},timer.getTime()+1)
			mist.scheduleFunction(HS_startTransmission,{groupName},timer.getTime()+2)
			HS_ADFlist[coa][count].group = groupName
			return entry.name
		end
	end
end

HS_restartMission = function()
local playerName,value

	if HS_timer.getTime() > 18000 and not HS_restartWarningFlag then
		HS_restartWarningFlag = true
		out('blue','MISSION WILL RESTART IN 5 MINUTES !',60)
		out('red','MISSION WILL RESTART IN 5 MINUTES !',60)
	end
	if HS_timer.getTime() > 18300 and not HS_restartFlag then
		HS_restartFlag = true
	end
	for playerName,value in pairs(mist.DBs.humansByName) do
		local playerUnit = Unit.getByName(playerName)
		if playerUnit and Unit.isActive(playerUnit) then
			HS_timeCounter = 0
			return
		end
	end
	HS_timeCounter = HS_timeCounter + 1
	if HS_timeCounter > 900 and not HS_restartFlag then
		HS_restartFlag = true
	end
end

HS_hasConvoyArrived = function(coa,convoyGroupName,endPosition)
local airfieldName,distance,closestOne

	local convoyGroup = HS_getGroup(convoyGroupName)
	if convoyGroup then
		airfieldName,distance = HS_closestAirfield(coa,HS_getAvgPos(convoyGroupName),HS_airfieldList)
		if distance < 1000 then
			HS_out(coa,convoyGroupName .. ' has arrived at ' .. airfieldName .. ' with supplies.',10)
			closestOne,distance = HS_closestInfantryGroupWithPrefix(coa,HS_getAvgPos(convoyGroupName),'Airfield')
			if closestOne then
				local closestGroup = HS_getGroup(closestOne)
				local groupSize = Group.getSize(closestGroup)
				closestGroup:destroy()
				local newSize = groupSize+Group.getSize(convoyGroup)*5
				HS_out(coa,airfieldName .. ' now has ' .. newSize .. ' combat-ready troops.',10)
				HS_addInfantryGroup(coa,closestOne,newSize,HS_getAvgPos(closestOne))
			end
			convoyGroup:destroy()
			mist.scheduleFunction(HS_createNewConvoy,{coa},timer.getTime()+mist.random(300))
			return
		end
		mist.scheduleFunction(HS_hasConvoyArrived,{'blue',convoyGroupName,endPosition},timer.getTime()+60)		
	end
end

HS_spotConvoy = function(coa,groupName)
	if HS_getGroup(groupName) then
		HS_out(HS_opponent[coa],'An enemy truck convoy has been spotted near ' .. HS_estimatePresentPosition(groupName),30)
		mist.scheduleFunction(HS_spotConvoy,{coa,groupName},timer.getTime()+150+mist.random(150))
	else
		HS_out(HS_opponent[coa],'Enemy truck convoy ' .. groupName .. ' has been destroyed. Nice work.',10)
	end
end

HS_spotMechanized = function(coa,groupName)
	if HS_getGroup(groupName) then
		HS_out(HS_opponent[coa],'An enemy mechanized platoon has been spotted near ' .. HS_estimatePresentPosition(groupName),30)
		mist.scheduleFunction(HS_spotMechanized,{coa,groupName},timer.getTime()+150+mist.random(150))
	else
		HS_out(HS_opponent[coa],'Enemy mechanized platoon ' .. groupName .. ' has been destroyed. Nice work.',10)
	end
end

HS_createNewConvoy = function(coa,zoneName)
	local convoyUnits = { blue = {'Hummer','Hummer','M 818','M 818','M1043 HMMWV Armament'} , red = {'Ural-375 ZU-23','UAZ-469','UAZ-469','Ural-4320T','Ural-4320T'}} -- list of units that make up the convoy
	local units = {}

	local position = mist.getRandPointInCircle(mist.utils.zoneToVec3(zoneName),mist.DBs.zonesByName[zoneName].radius)
	local endPosition = mist.getRandPointInCircle(Airbase.getPosition(Airbase.getByName(HS_airfieldList[coa][mist.random(#HS_airfieldList[coa])])).p,1000)
	if position then
		HS_convoyCounter[coa] = HS_convoyCounter[coa] + 1
		local groupName = coa .. 'convoy #' .. HS_convoyCounter[coa]
		for i =1,#convoyUnits[coa] do
			table.insert(units,
			{
				["x"] = position.x+i*15,
				["y"] = position.y+i*15,
				["type"] = convoyUnits[coa][i],
				["name"] =   groupName .. ' Unit #' .. i,
				["heading"] = 0,
			})
		end
		if coa == 'blue' then
			mist.dynAdd({country = 'USA', category = 'GROUND_UNIT', name = groupName, hidden = false, units = units})
		end
		if coa == 'red' then
			mist.dynAdd({country = 'RUSSIA', category = 'GROUND_UNIT', name = groupName, hidden = false, units = units})
		end
		HS_groupDoNotDisperse(groupName) -- keep driving if attacked
		mist.groupToRandomPoint({group = HS_getGroup(groupName), point = mist.utils.makeVec3(endPosition)})
		mist.scheduleFunction(HS_hasConvoyArrived,{coa,groupName,endPosition},timer.getTime()+60)
		mist.scheduleFunction(HS_spotConvoy,{coa,groupName},timer.getTime()+150+mist.random(150))
		return groupName
	end
end

HS_scheduleMissionRestart = function()

	mist.scheduleFunction(HS_restartMission,{},timer.getTime()+5,10) -- schedule possible mission restart
end

mist.addEventHandler(customEventHandler) -- initialize event handler

local count

for count = 1,20 do
	table.insert(HS_ADFlist.blue,{name = 'FM '.. 30+(count-1)*0.5 .. ' MHz', frequency = (30+(count-1)*0.5)*1E6, modulation = 1, group = nil})
end

HS = {
	out = HS_out,
	outUnit = HS_outUnit,
	onBecomesActiveDo = HS_onBecomesActiveDo,
	onBecomesInactiveDo = HS_onBecomesInactiveDo,
	addRadioItem = HS_addRadioItem,
	removeRadioItems = HS_removeRadioItems,
	onTouchDownDo = HS_onTouchDownDo,
	onTakeOffDo = HS_onTakeOffDo,
	addInfantryGroup = HS_addInfantryGroup,
	addGroundGroup = HS_addGroundGroup,
	groundBattle = HS_groundBattle,
	makeInfantryMove = HS_makeInfantryMove,
	loadTroops = HS_loadTroops,
	offloadTroops = HS_offloadTroops,
	setNumberOfTroopsInCabin = HS_setNumberOfTroopsInCabin,
	getNumberOfTroopsInCabin = HS_getNumberOfTroopsInCabin,
	setNumberOfRescuedPilotsInCabin = HS_setNumberOfRescuedPilotsInCabin,
	getNumberOfRescuedPilotsInCabin = HS_getNumberOfRescuedPilotsInCabin,
	declareAsAI = HS_declareAsAI,
	getUnitCoalition = HS_getUnitCoalition,
	getGroupCoalition = HS_getGroupCoalition,
	isGroupInfantry = HS_isGroupInfantry,
	estimatePresentPosition = HS_estimatePresentPosition,
	addCheckForSmoke = HS_addCheckForSmoke,
	addCheckForFlare = HS_addCheckForFlare,
	addCheckForIncoming = HS_addCheckForIncoming,
	addReportIAS = HS_addReportIAS,
	generateAirDefence = HS_generateAirDefence,
	addHoverGuidance = HS_addHoverGuidance,
	flyFighterMission = HS_flyFighterMission,
	flyHelicopterSEADMission = HS_flyHelicopterSEADMission,
	initializeFARP = HS_initializeFARP,
	totalInfantrySize = HS_totalInfantrySize,
	clearADFlist = HS_clearADFlist,
	assignADF = HS_assignADF,
	scheduleMissionRestart = HS_scheduleMissionRestart,
	createNewConvoy = HS_createNewConvoy,
	spotConvoy = HS_spotConvoy,
	spotMechanized = HS_spotMechanized,
}
