numberOfInfantryGroups = 10
numberOfConvoys = {blue = 2, red = 2}
numberOfFighterJets = {blue = 2, red = 2}
numberOfHelicopterSEAD = {blue = 2, red = 2}

loadTroopsRequested = function(playerGroupName)
	HS.loadTroops(playerGroupName)
end

offloadTroopsRequested = function(playerGroupName)
	HS.offloadTroops(playerGroupName)
end

updating = function(playerGroupName)
local groupName,value,counter

	local coa = HS.getGroupCoalition(playerGroupName)
	for groupName,value in pairs(HS_groupsInNeed[coa]) do
		local group = Group.getByName(groupName)
		if group then
			local roundsLeft = 0
			local units = Group.getUnits(group)
			for counter = 1,#units do
				roundsLeft = roundsLeft + Unit.getAmmo(units[counter])[1].count
			end
			HS.out(coa,groupName .. ' located at ' .. HS.estimatePresentPosition(groupName) .. ' with ' .. Group.getSize(group) .. ' men and ' .. roundsLeft .. ' rounds of ammo left., broadcasting on ' .. HS.assignADF(coa,groupName),20)
		end
	end
end

toDoListRequested = function(playerGroupName)
	local coa = HS.getGroupCoalition(playerGroupName)
	HS.out(coa,'This is ' .. playerGroupName .. '. Ready for task assignment. All units in distress, report in. Over.',10)
	mist.scheduleFunction(updating,{playerGroupName},timer.getTime()+10)
end

troopCountRequested = function(playerGroupName)
local count

	local coa = HS.getGroupCoalition(playerGroupName)
	local group = Group.getByName(playerGroupName)
	local units = Group.getUnits(group)
	for count = 1,#units do
		local playerName = Unit.getName(units[count])
		HS.out(coa,'This is ' .. playerName .. '. There are ' .. HS.getNumberOfTroopsInCabin(playerName) .. ' infantry troops on board',10)
		HS.out(coa,'This is ' .. playerName .. '. There are ' .. HS.getNumberOfRescuedPilotsInCabin(playerName) .. ' rescued pilots on board',10)
	end
end

presentPositionRequested = function(playerGroupName)
	local playerName = Unit.getName(Group.getUnits(Group.getByName(playerGroupName))[1])
	local coa = HS_getGroupCoalition(playerGroupName)
	HS.outUnit(playerName,'[copilot for ' .. playerName .. '] I estimate our present position to be at ' .. HS.estimatePresentPosition(playerGroupName),30)
end

playerHasBecomeActive = function(playerName)
	local playerUnit = Unit.getByName(playerName)
	if playerUnit then
		local coa = HS.getUnitCoalition(playerName)
		HS.out(coa,playerName .. ' has become active.',10)
		HS.setNumberOfTroopsInCabin(playerName,0)
		HS.setNumberOfRescuedPilotsInCabin(playerName,0)
		local playerGroupName = Group.getName(Unit.getGroup(playerUnit))
		if playerUnit:getTypeName() == 'UH-1H' or playerUnit:getTypeName() == 'Mi-8MT' then
			HS.addRadioItem(playerGroupName,'copilot, estimate present position',presentPositionRequested,{playerGroupName})
			HS.addRadioItem(playerGroupName,'request assignment',toDoListRequested,{playerGroupName})
			HS.addRadioItem(playerGroupName,'load troops',loadTroopsRequested,{playerGroupName})
			HS.addRadioItem(playerGroupName,'offload troops',offloadTroopsRequested,{playerGroupName})
			HS.addRadioItem(playerGroupName,'number of troops on board',troopCountRequested,{playerGroupName})
			HS.addCheckForIncoming(playerName)
			HS.outUnit(playerName,'Reinforce friendly troops and take out enemy infantry. Provide CSAR. Use F10 to load/unload troops (infantry and/or pilots down).',30)
		end
		HS.addCheckForFlare(playerGroupName)
		HS.onTakeOffDo(playerName,HS.out,{coa,playerName .. ' has taken off',10})
		HS.onTouchDownDo(playerName,HS.out,{coa,playerName .. ' has landed',10})
		if playerName == '401' then
			mist.scheduleFunction(HS.declareAsAI,{'Russian AI Helicopter Group #1'},timer.getTime()+10)
		end
		if playerName == 'Chevy 1-1' then
			mist.scheduleFunction(HS.declareAsAI,{'US AI Helicopter Group #1'},timer.getTime()+10)
		end
	end
end

playerHasBecomeInactive = function(playerName)
	local coa = HS.getUnitCoalition(playerName)
	HS.out(coa,playerName .. ' has become inactive.',10)
	HS.removeRadioItems(playerName)
end

local count

HOVER_points = {blue = {}, red = {}} -- Vec3 coordinates of points over which you want to hover, initialize as empty for both coalitions

-- table.insert(HOVER_points.blue,{position = StaticObject.getPosition(StaticObject.getByName('US cargo')).p,minD = 10,maxD = 300,minH = 10,maxH = 20, duration = 0}) -- now initialize for blue coalition. Meaning of parameters: minD = distance in meters from dead center position that is still considered OK. maxD = distance from object where crew chief instructions begin, minH = height in meters above ground below which "up" instruction is given, maxH = height above which "down" instruction is given
-- table.insert(HOVER_points.red,{position = StaticObject.getPosition(StaticObject.getByName('Russian cargo')).p,minD = 10,maxD = 300,minH = 10,maxH = 20, duration = 0}) -- now initialize for blue coalition. Meaning of parameters: minD = distance in meters from dead center position that is still considered OK. maxD = distance from object where crew chief instructions begin, minH = height in meters above ground below which "up" instruction is given, maxH = height above which "down" instruction is given

for count = 1, #mist.DBs.MEunitsByCat.helicopter do
	HS.onBecomesActiveDo(mist.DBs.MEunitsByCat.helicopter[count].unitName,playerHasBecomeActive,{mist.DBs.MEunitsByCat.helicopter[count].unitName})
	HS.onBecomesInactiveDo(mist.DBs.MEunitsByCat.helicopter[count].unitName,playerHasBecomeInactive,{mist.DBs.MEunitsByCat.helicopter[count].unitName})
end

HS.onBecomesActiveDo('Hawg 1-1',playerHasBecomeActive,{'Hawg 1-1'})
HS.onBecomesInactiveDo('Hawg 1-1',playerHasBecomeInactive,{'Hawg 1-1'})

HS.addInfantryGroup('USA','Airfield Group Kobuleti',75,mist.utils.makeVec2(mist.utils.zoneToVec3('Kobuleti Troops Zone')))
HS.addInfantryGroup('RUSSIA','Airfield Group Kutaisi',75,mist.utils.makeVec2(mist.utils.zoneToVec3('Kutaisi Troops Zone')))
HS.initializeFARP('FARP London')
HS.initializeFARP('FARP Vetka')
HS.addInfantryGroup('USA','Airfield Group London',75,mist.utils.makeVec2(mist.utils.zoneToVec3('FARP London Troops Zone')))
HS.addInfantryGroup('RUSSIA','Airfield Group Vetka',75,mist.utils.makeVec2(mist.utils.zoneToVec3('FARP Vetka Troops Zone')))
HS.groundBattle(numberOfInfantryGroups,20,'Ground Battle Zone',{blue = 'US Zone',red = 'Russian Zone'})
HS.generateAirDefence('red',3,'Russian AAA Zone')
HS.generateAirDefence('blue',3,'US AAA Zone')

for count = 1,numberOfFighterJets.blue do
	HS.flyFighterMission('blue','Tiger Group #' .. count)
end
for count = 1,numberOfFighterJets.red do
	HS.flyFighterMission('red','Mig Group #' .. count)
end

for count = 1,numberOfHelicopterSEAD.blue do
	HS.flyHelicopterSEADMission('blue','US Helicopter SEAD Group #' .. count)
end

for count = 1,numberOfHelicopterSEAD.red do
	HS.flyHelicopterSEADMission('red','Russian Helicopter SEAD Group #' .. count)
end

for count = 1,numberOfConvoys.blue do
	mist.scheduleFunction(HS.createNewConvoy,{'blue','US Zone'},timer.getTime()+mist.random(300))
end

for count = 1,numberOfConvoys.blue do
	mist.scheduleFunction(HS.createNewConvoy,{'red','Russian Zone'},timer.getTime()+mist.random(300))
end

mist.scheduleFunction(HS.spotMechanized,{'blue','US Mechanized Group'},timer.getTime()+150+mist.random(150))
mist.scheduleFunction(HS.spotMechanized,{'red','Russian Mechanized Group'},timer.getTime()+150+mist.random(150))

HS.scheduleMissionRestart()
